package ru.dbotthepony.kstarbound.defs

import com.google.common.collect.ImmutableList
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory
import ru.dbotthepony.kvector.vector.Vector2d

@JsonFactory
data class MovementParameters(
	val flySpeed: Double? = null,
	val airFriction: Double? = null,
	val airJumpProfile: JumpProfile? = null,
	val airForce: Double? = null,

	val runSpeed: Double? = null,
	val walkSpeed: Double? = null,
	val mass: Double? = null,

	// TODO: А оно вообще используется? Как по мне движок старбаунда генерирует коллизию из пикселей текстуры
	val collisionPoly: ImmutableList<Vector2d>? = null,
	val crouchingPoly: ImmutableList<Vector2d>? = null,
	val standingPoly: ImmutableList<Vector2d>? = null,
)
